"""
Django settings for wei project.

Generated by 'django-admin startproject' using Django 2.0.6.

For more information on this file, see
https://docs.djangoproject.com/en/2.0/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/2.0/ref/settings/
"""

import os
import dj_database_url

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))


# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/2.0/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = os.environ.get('SECRET_KEY','jmkdr(b)3w)-0o9n$(%%lv%m6)+o^@0i(hqpnjbs8ni13(^hp^')

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = os.environ.get("DEBUG", "False") == "True"
#OVERRIDE_PERMISSIONS = False
ALLOWED_HOSTS = []+os.environ.get("HOST", "localhost:8001").split(',')

CORS_ORIGIN_ALLOW_ALL = False
CORS_ALLOW_METHODS = (
    'DELETE',
    'GET',
    'OPTIONS',
    'PATCH',
    'POST',
    'PUT',
)
CORS_ORIGIN_WHITELIST = [
                            'adhesion2.test.bde-insa-lyon.fr',
                            'adhesion2.bde-insa-lyon.fr',
                            'standva.bde-insa-lyon.fr',
                            'adhesion2.bde-insa-lyon.fr',
                            'localhost:4200',
                            'localhost:8000'
                        ] + os.environ.get('DOMAINS', '').split(',')
CORS_ALLOW_CREDENTIALS = True

CSRF_TRUSTED_ORIGINS = ['adhesion2.bde-insa-lyon.fr',
                        'localhost:8000',
                        'localhost:8001',
                        'localhost:4200',
                       ] + os.environ.get('DOMAINS', '').split(',')

if DEBUG:
    CORS_ORIGIN_ALLOW_ALL = True
    os.environ["OAUTHLIB_INSECURE_TRANSPORT"]='1'
OVERRIDE_PERMISSIONS = os.environ.get('OVERRIDE_PERMISSIONS', 'False') == 'True'
# Application definition

INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'account',
    'rest_framework',
    'oauth2_provider', #tkt, WEI délègue l'authentification à Adhésion
    'api',
    'django_filters',
    'corsheaders'
]

MIDDLEWARE = [
    'corsheaders.middleware.CorsMiddleware',
    'corsheaders.middleware.CorsPostCsrfMiddleware',
    'django.middleware.common.BrokenLinkEmailsMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'oauth2_provider.middleware.OAuth2TokenMiddleware', #si on le met avant AuthentificationMiddleWare, il va remplir tt le tps l'atribut request.user
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
]

ROOT_URLCONF = 'wei.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [os.path.join(BASE_DIR, 'templates')]
        ,
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'wei.wsgi.application'


# Database
# https://docs.djangoproject.com/en/2.0/ref/settings/#databases

DATABASES = {
    'default': dj_database_url.config(default='sqlite:///' + os.path.join(BASE_DIR, 'db.sqlite3'), conn_max_age=600)
}
DATE_WEI = os.environ.get('DATE_WEI','2018-09-01') #la date de l'évènement WEI, pour savoir qui sera majeur
PLACES_MAX = int(os.environ.get('PLACES_MAX', '460'))

# Password validation
# https://docs.djangoproject.com/en/2.0/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]


# Internationalization
# https://docs.djangoproject.com/en/2.0/topics/i18n/

LANGUAGE_CODE = 'fr-fr'

TIME_ZONE = 'UTC'

USE_I18N = True

USE_L10N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/2.0/howto/static-files/

STATIC_URL = '/static/'
STATIC_ROOT = os.path.join(BASE_DIR, "staticfiles")
STATICFILES_DIRS = [
    os.path.join(BASE_DIR, "static")
]

ADHESION_CLIENT_ID=os.environ.get("ADHESION_CLIENT_ID")
ADHESION_CLIENT_SECRET=os.environ.get("ADHESION_CLIENT_SECRET")
ADHESION_URL=os.environ.get("ADHESION_URL", "https://locahost:8000") #sans le / à la fin
ADHESION_COOLDOWN = int(os.environ.get("ADHESION_COOLDOWN", 10)) #delta en minutes autorisé pour la mise en cache des données User
OAUTH2_PROVIDER = {
    'RESOURCE_SERVER_INTROSPECTION_URL' :ADHESION_URL + '/o/introspect/',
    'RESOURCE_SERVER_AUTH_TOKEN': os.environ.get('RESOURCE_SERVER_AUTH_TOKEN'), #y'aura des erreurs en mode JSONDecodeError si le token est invalide
    #'RESOURCE_SERVER_TOKEN_CACHING_SECONDS': 1 if DEBUG else 3600
}
PAIEMENT_API_URL = os.environ.get('PAIEMENT_API_URL','https://paiements.test.bde-insa-lyon.fr/api/')

AUTHENTICATION_BACKENDS = {
    'django.contrib.auth.backends.ModelBackend',
    'account.backend.AdhesionOauthBackend',
}
AUTH_USER_MODEL = 'account.User'

REST_FRAMEWORK = {
    'DEFAULT_AUTHENTICATION_CLASSES': (
        'oauth2_provider.contrib.rest_framework.OAuth2Authentication',
    ),
    'DEFAULT_FILTER_BACKENDS': ('django_filters.rest_framework.DjangoFilterBackend',),
    'DEFAULT_PAGINATION_CLASS': 'rest_framework.pagination.LimitOffsetPagination'
}

LOGGING = {
    'version': 1,
    'disable_existing_loggers': False,
    'handlers': {
        'console': {
            'class': 'logging.StreamHandler',
        },
        'mail_admins_debug': {
            'level': 'ERROR',
            'class': 'django.utils.log.AdminEmailHandler',
            'include_html': True,
        }
    },
    'loggers': {
        'introspector': { # donne des infos sur la vérification des tokens OAuth aurpès de Adhésion
            'handlers': ['console'],
            'level': 'DEBUG'
        },
        'models':{
            'handlers': ['console'],
            'level': 'DEBUG'
        },
        'adhesion_api':{
            'handlers': ['console'],
            'level': 'DEBUG'
        },
        'api' : {
            'handlers':['console'],
            'level':'DEBUG'
        },
        'permissions': {
            'handlers':['console'],
            'level': 'DEBUG'
        }
    },
}
